﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="ChatWindow.aspx.cs" Inherits="dotnetLIVEHELP.Web.ChatWindow" %>
<%@ Import namespace="Resources"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%#strings.Form_ChatForm_Title %></title>     
</head>
<body>    
    <form id="form1" runat="server">   
       <div>
         <table>
         <tr>
                 <td colspan="2" style="height: 56px">
                     &nbsp;<img src="Images/dotnetlivehelplogo.png" /></td>           
             </tr>
             <tr>
                 <td colspan="2" style="height: 174px">
                 <div id="pnMessage" style="border-color:#D8E4F8;border-width:1px;border-style:solid;height:248px;width:510px;overflow:auto;"/>
                 </td>                
             </tr>
             <tr>
             <td colspan="2">
                 &nbsp;
                 <img  id="btTranscript" onclick="javascript:transcriptLog()" title='<%#strings.Form_ChatForm_TranscriptTitle %>' src="Images/mail.png" style="border-width:0px;" alt='<%#strings.Form_ChatForm_TranscriptAlt %>' />
                 &nbsp;
                 <img  id="btPrint" onclick="javascript:printLog()" title='<%#strings.Form_ChatForm_PrintTitle %>' src="Images/print.png" style="border-width:0px;" alt='<%#strings.Form_ChatForm_PrintAlt %>' />  
             </td>               
              </tr>
             <tr>
                 <td style="height: 148px">
                 <textarea id="tbMessage" onkeypress="checkKey(event)" style="border-color:#7A96DF;border-width:1px;border-style:solid;height:148px;width:510px;"></textarea>
                 </td>
                 <td style="height: 148px">
                 </td>                 
             </tr> 
             <tr>
             <td align="right">
             <input type="button" id="btSend" onclick="sendMessage()" style="width: 105px; height: 40px;" value='<%#strings.Form_ChatForm_Send %>'/>             
             </td>
             </tr>           
         </table>
          <input id="iSession" type="hidden" value='<%#this.chatSession.ID %>' /></div> 
          
           <script type="text/javascript">   
    var timer=window.setInterval("getMessages()",3000);
    var Button= document.getElementById('btSend');
    var TextBox = document.getElementById('tbMessage');
    var timerFinished=false;
    var isClear=false;
    var first=true;
    Button.disabled=true; 
    window.onunload = closeWindow;
    window.onload = testAJAX;
    var testAJAX=false;
    
    function testAJAX()
    {   
        ChatWindow.Test();              
        testAJAX=true;
    }
    
    function checkKey(e)
    {    
   
       var TextBox =document.getElementById('tbMessage'); 
       
        if(window.event) // IE
        {               
            if(e.keyCode==13&&!e.ctrlKey&&!e.shiftKey)
            {           
                sendMessage();
                e.returnValue = false;                     
            } 
            
            if(e.keyCode==10)
            {            
               e.keyCode=13;
               return;
            }
            
            if(e.keyCode==13&&e.ctrlKey)
            {           
              TextBox.value=TextBox.value+'\n';
              var tr=TextBox.createTextRange();
              tr.collapse(false);
              tr.select();               
              TextBox.focus();            
            }
            return;
        }
        else if(e.which) // Netscape/Firefox
        {        
            if(e.which==13&&!e.ctrlKey&&!e.shiftKey)
            {
                sendMessage();
                e.preventDefault();                    
            } 
            else if(e.which==13&&e.ctrlKey){
               TextBox.value=TextBox.value+'\r';
            }
                        
        }       
           TextBox.focus();    
    }

    
    function getMessages()
    {
         var sessionID=document.getElementById('iSession').value;
         window.clearInterval(timer);
         if(testAJAX)
          ChatWindow.GetMessages(sessionID,getMessagesCallback);   
          else
          {
          
          if(parent.frames.length==0)
           window.location.href="ChatWindowWithFrame.aspx?chatId="+sessionID;  
           else{          
           parent.frames['hiddenFrame'].location.href ="message.ashx?chatId="+sessionID+"&func=get";          
           }                
          }                 
	    
    } 
    function getMessagesCallback(result)
    {
    if(result.length>0)    
       var message;  
        if(!testAJAX)  
            message=result;
        else message=result.value;        
       addMessage(message);
       if(!timerFinished)
        timer=window.setInterval("getMessages()",3000);   
    }
    
    function sendMessage()
    {
    var Button= document.getElementById('btSend');
    if(Button.disabled)
        return;
            
    window.clearInterval(timer);
    var TextBox = document.getElementById('tbMessage');
    var sessionID=document.getElementById('iSession').value;    
       
            
       Button.disabled=true;       
       if(testAJAX)
          ChatWindow.SendMessage(sessionID,TextBox.value,sendMessageCallback);    
          else
          {          
            if(parent.frames.length==0)
                window.location.href="ChatWindowWithFrame.aspx?chatId="+sessionID;  
            else          
                parent.frames['hiddenFrame'].location.href ="message.ashx?chatId="+sessionID+"&func=set&mess="+escape(TextBox.value);
          }   
           
             
    }   
    function sendMessageCallback(result)
    {
    var TextBox = document.getElementById('tbMessage');
    var Button= document.getElementById('btSend');
    
      var message;  
        if(!testAJAX)  
            message=result;
        else message=result.value;
        
       addMessage(message); 
       TextBox.value='';        
       Button.disabled=false; 
       if(!timerFinished) 
        timer=window.setInterval("getMessages()",3000);  
        
        TextBox.focus();        
    }  
    
    function addMessage(message)
    {
        var Button= document.getElementById('btSend');
        var TextBox = document.getElementById('tbMessage');
        
        if(message=='null')
        {
           testAJAX();
            return;  
        } 
        if(message==''||message=='null')
         return;
                    
        var Panel = document.getElementById('pnMessage');
       
      
         if(message.length>5&&message.substring(0,6)=='Clear;')
         {
         
             if(isClear)
             return;
             
             Button.disabled=false;
              TextBox.disabled=false;
             Panel.innerHTML ='';  
             
             ButtonsEnable();
             
             isClear=true; 
             message= message.substring(6);
                        
             if(message==''||message=='null')
                return;
         } 
         if(message.length>8&&message.substring(0,9)=='Finished;')
         {
            message= message.substring(9);
                        
            if(message!=''&&message!='null')
             {
                Panel.innerHTML = Panel.innerHTML + message; 
                Panel.scrollTop= Panel.scrollHeight + Panel.offsetHeight;        
             }
             Button.disabled=true;
              TextBox.disabled=true;
               timerFinished=true;             
             return;
         } 
         else
          if(!first&&!isClear)
         {         
        
         Button.disabled=false;
          TextBox.disabled=false;
         Panel.innerHTML ='';  
         ButtonsEnable();
         isClear=true;             
         
         }         
        Panel.innerHTML = Panel.innerHTML + message; 
        Panel.scrollTop= Panel.scrollHeight + Panel.offsetHeight;
        first=false;
    }  
    
    function closeWindow()
    {
        var sessionID=document.getElementById('iSession').value;
        if(testAJAX)
            ChatWindow.FinishSession(sessionID);
         else
          {          
          if(parent.frames.length>0)                  
           parent.frames['hiddenFrame'].location.href ="message.ashx?chatId="+sessionID+"&func=finish";          
                           
          }      
    }
    
    function transcriptLog()
    {
    if(!buttonsEnable)
        return;
    var sessionID=document.getElementById('iSession').value;
    window.open('Transcript.aspx?session_id='+sessionID+'&type=sendtranscript', '_blank', 'width=600, height=600, resizable=0, scrollbars=1, toolbar=0, status=0');
    }
    
    function printLog()
    {
    if(!buttonsEnable)
        return;
    var sessionID=document.getElementById('iSession').value;
    window.open('Transcript.aspx?session_id='+sessionID+'&type=sendprinter', '_blank', 'width=600, height=600, resizable=0, scrollbars=1, toolbar=0, status=0');
    }
    
    var buttonsEnable=false;
    function ButtonsEnable()
    {
         var imgBtn=document.getElementById('btTranscript');
         if(imgBtn!=null)
         imgBtn.style.cursor="pointer";         
         var imgBtn1=document.getElementById('btPrint');
         if(imgBtn1!=null)
         imgBtn1.style.cursor="pointer";
        buttonsEnable=true;
    }
    
    </script>   
    </form>     
</body>
</html>